Index: branches/Scheduling/HeuristicLab.Encodings.SchedulingEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Encodings.SchedulingEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Encodings.SchedulingEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 6364)
@@ -31,5 +31,5 @@
 namespace HeuristicLab.Encodings.SchedulingEncoding.JobSequenceMatrix.Manipulators {
 
-  [Item("JSM Swap Manipulator", "Represents a manipulation operation inserting parts of the individual at another position.")]
+  [Item("JSM Swap Manipulator", "Represents a manipulation operation swapping parts of the individual.")]
   [StorableClass]
   public class JSMSwapManipulator : JSMManipulator {
Index: branches/Scheduling/HeuristicLab.Encodings.SchedulingEncoding/3.3/Plugin.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Encodings.SchedulingEncoding/3.3/Plugin.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Encodings.SchedulingEncoding/3.3/Plugin.cs	(revision 6364)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Encodings.SchedulingEncoding {
-  [Plugin("HeuristicLab.Encodings.SchedulingEncoding", "3.3.3.6266")]
+  [Plugin("HeuristicLab.Encodings.SchedulingEncoding", "3.3.3.6294")]
   [PluginFile("HeuristicLab.Encodings.SchedulingEncoding-3.3.dll", PluginFileType.Assembly)]
   public class HeuristicLabEncodingsSchedulingEncodingPlugin : PluginBase {
Index: branches/Scheduling/HeuristicLab.Encodings.SchedulingEncoding/3.3/ScheduleEncoding/Resource.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Encodings.SchedulingEncoding/3.3/ScheduleEncoding/Resource.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Encodings.SchedulingEncoding/3.3/ScheduleEncoding/Resource.cs	(revision 6364)
@@ -33,9 +33,11 @@
   [Item("Resource Class", "Represents a resource used in scheduling problems.")]
   [StorableClass]
-  public class Resource : IndexedScheduledTaskList {
+  public class Resource : Item {
     [StorableConstructor]
     protected Resource(bool deserializing) : base(deserializing) { }
     protected Resource(Resource original, Cloner cloner)
       : base(original, cloner) {
+        this.Index = cloner.Clone(original.Index);
+        this.Tasks = cloner.Clone(original.Tasks);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -43,5 +45,29 @@
     }
 
-    public Resource(IntValue index) : base (index) { }
+    public Resource(IntValue index) : base () {
+      Index = index;
+      Tasks = new ItemList<ScheduledTask>();
+    }
+
+    public IntValue Index {
+      get;
+      set;
+    }
+    public ItemList<ScheduledTask> Tasks {
+      get;
+      set;
+    }
+
+
+    public DoubleValue TotalDuration {
+      get {
+        double result = 0;
+        foreach (ScheduledTask t in Tasks) {
+          if (t.EndTime.Value > result)
+            result = t.EndTime.Value;
+        }
+        return new DoubleValue(result);
+      }
+    }
 
     public override string ToString() {
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 6364)
@@ -62,10 +62,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="GanttChart.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="GanttChart.Designer.cs">
-      <DependentUpon>GanttChart.cs</DependentUpon>
-    </Compile>
     <Compile Include="JobShopSchedulingProblemView.cs">
       <SubType>UserControl</SubType>
@@ -76,10 +70,4 @@
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="ScheduleView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ScheduleView.Designer.cs">
-      <DependentUpon>ScheduleView.cs</DependentUpon>
-    </Compile>
     <Compile Include="SchedulingProblemImportDialog.cs">
       <SubType>Form</SubType>
@@ -126,4 +114,8 @@
       <Project>{DBECB8B0-B166-4133-BAF1-ED67C3FD7FCA}</Project>
       <Name>HeuristicLab.Encodings.PermutationEncoding-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.SchedulingEncoding.Views\3.3\HeuristicLab.Encodings.SchedulingEncoding.Views-3.3.csproj">
+      <Project>{0C378762-D5DB-488A-8931-2BA42B1B7CBF}</Project>
+      <Name>HeuristicLab.Encodings.SchedulingEncoding.Views-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Encodings.SchedulingEncoding\3.3\HeuristicLab.Encodings.SchedulingEncoding-3.3.csproj">
@@ -181,12 +173,6 @@
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="GanttChart.resx">
-      <DependentUpon>GanttChart.cs</DependentUpon>
-    </EmbeddedResource>
     <EmbeddedResource Include="JobShopSchedulingProblemView.resx">
       <DependentUpon>JobShopSchedulingProblemView.cs</DependentUpon>
-    </EmbeddedResource>
-    <EmbeddedResource Include="ScheduleView.resx">
-      <DependentUpon>ScheduleView.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="SchedulingProblemImportDialog.resx">
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs	(revision 6364)
@@ -1,3 +1,4 @@
-﻿namespace HeuristicLab.Problems.Scheduling.Views {
+﻿using HeuristicLab.Encodings.SchedulingEncoding.Views;
+namespace HeuristicLab.Problems.Scheduling.Views {
   partial class JobShopSchedulingProblemView {
     /// <summary> 
@@ -29,5 +30,5 @@
       this.tabPage1 = new System.Windows.Forms.TabPage();
       this.tabPage2 = new System.Windows.Forms.TabPage();
-      this.ganttChart = new HeuristicLab.Problems.Scheduling.Views.GanttChart();
+      this.ganttChart = new GanttChart();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.tabControl1.SuspendLayout();
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs	(revision 6364)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Scheduling.Views {
-  [Plugin("HeuristicLab.Problems.Scheduling.Views", "3.3.3.6266")]
+  [Plugin("HeuristicLab.Problems.Scheduling.Views", "3.3.3.6294")]
   [PluginFile("HeuristicLab.Problems.Scheduling.Views-3.3.dll", PluginFileType.Assembly)]
   public class HeuristicLabProblemsSchedulingViewsPlugin : PluginBase {
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs	(revision 6364)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.0.6266")]
+[assembly: AssemblyFileVersion("3.3.0.6294")]
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMDecoder.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMDecoder.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMDecoder.cs	(revision 6364)
@@ -36,5 +36,5 @@
 
 namespace HeuristicLab.Problems.Scheduling.Decoders {
-  [Item("Job Sequencing Matrix Decoder", "Applies the GifflerThompson algorithm to create an active schedule from a JobSequencing Matrix.")]
+  [Item("Job Sequence Matrix Decoder", "Applies the GifflerThompson algorithm to create an active schedule from a JobSequence Matrix.")]
   [StorableClass]
   public class JSMDecoder : SchedulingDecoder<JSMEncoding>, IStochasticOperator, IJSSPOperator {
@@ -76,5 +76,5 @@
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
-      Parameters.Add(new LookupParameter<ItemList<Job>>("JobData", "Job data taken from the JSSP - Instance."));
+      Parameters.Add(new LookupParameter<ItemList<Job>>("JobData", "Job data taken from the Schedulingproblem - Instance."));
     }
 
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/PRVDecoder.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/PRVDecoder.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/PRVDecoder.cs	(revision 6364)
@@ -197,43 +197,10 @@
     }
 
-    private ItemList<Task> GetEarliestNotScheduledTasks() {
-      ItemList<Task> result = new ItemList<Task>();
-      foreach (Job j in jobs) {
-        foreach (Task t in j.Tasks) {
-          if (!t.IsScheduled.Value) {
-            result.Add(t);
-            break;
-          }
-        }
-      }
-      return result;
-    }
-    private Task GetTaskWithMinimalEC(ItemList<Task> earliestTasksList) {
-      double minEct = double.MaxValue;
-      Task result = null;
-      foreach (Task t in earliestTasksList) {
-        double ect = GTAlgorithmUtils.ComputeEarliestCompletionTime(t, resultingSchedule);
-        if (ect < minEct) {
-          result = t;
-          minEct = ect;
-        }
-      }
-      return result;
-    }
-    private ItemList<Task> GetConflictSetForTask(Task conflictedTask, ItemList<Task> earliestTasksList) {
-      ItemList<Task> result = new ItemList<Task>();
-      double conflictedCompletionTime = GTAlgorithmUtils.ComputeEarliestCompletionTime(conflictedTask, resultingSchedule);
-      foreach (Task t in earliestTasksList) {
-        if (t.ResourceNr.Value == conflictedTask.ResourceNr.Value) {
-          if (GTAlgorithmUtils.ComputeEarliestStartTime(t, resultingSchedule) < conflictedCompletionTime)
-            result.Add(t);
-        }
-      }
-      return result;
-    }
+
+
     private Task SelectTaskFromConflictSet(ItemList<Task> conflictSet, int ruleIndex, int nrOfRules) {
       if (conflictSet.Count == 1)
         return conflictSet[0];
-      
+
       ruleIndex = ruleIndex % nrOfRules;
       switch (ruleIndex) {
@@ -249,5 +216,5 @@
         case 9: return RandomRule(conflictSet);
         default: return RandomRule(conflictSet);
-      }  
+      }
     }
 
@@ -265,15 +232,16 @@
       //GT-Algorithm
       //STEP 0 - Compute a list of "earliest operations"
-      ItemList<Task> earliestTasksList = GetEarliestNotScheduledTasks();
-      int currentDecisionIndex = 0;
+      ItemList<Task> earliestTasksList = GTAlgorithmUtils.GetEarliestNotScheduledTasks(jobs);
+      //int currentDecisionIndex = 0;
       while (earliestTasksList.Count > 0) {
         //STEP 1 - Get earliest not scheduled operation with minimal earliest completing time
-        Task minimal = GetTaskWithMinimalEC(earliestTasksList);
+        Task minimal = GTAlgorithmUtils.GetTaskWithMinimalEC(earliestTasksList, resultingSchedule);
 
         //STEP 2 - Compute a conflict set of all operations that can be scheduled on the machine the previously selected operation runs on
-        ItemList<Task> conflictSet = GetConflictSetForTask(minimal, earliestTasksList);
+        ItemList<Task> conflictSet = GTAlgorithmUtils.GetConflictSetForTask(minimal, earliestTasksList, jobs, resultingSchedule);
 
         //STEP 3 - Select an operation from the conflict set (various methods depending on how the algorithm should work..)
-        Task selectedTask = SelectTaskFromConflictSet(conflictSet, solution.PriorityRulesVector [currentDecisionIndex++], solution.NrOfRules.Value);
+        //Task selectedTask = SelectTaskFromConflictSet(conflictSet, solution.PriorityRulesVector [currentDecisionIndex++], solution.NrOfRules.Value);
+        Task selectedTask = SelectTaskFromConflictSet(conflictSet, solution.PriorityRulesVector[minimal.JobNr.Value], solution.NrOfRules.Value);
 
         //STEP 4 - Adding the selected operation to the current schedule
@@ -283,5 +251,5 @@
 
         //STEP 5 - Back to STEP 1
-        earliestTasksList = GetEarliestNotScheduledTasks();
+        earliestTasksList = GTAlgorithmUtils.GetEarliestNotScheduledTasks(jobs);
       }
 
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MeanTardinessEvaluator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MeanTardinessEvaluator.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/MeanTardinessEvaluator.cs	(revision 6364)
@@ -31,9 +31,10 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Encodings.SchedulingEncoding;
+using HeuristicLab.Problems.Scheduling.Interfaces;
 
 namespace HeuristicLab.Problems.Scheduling.Evaluators {
-  [Item("Men tardiness Evaluator", "Represents an evaluator using the mean tardiness of a schedule.")]
+  [Item("Mean tardiness Evaluator", "Represents an evaluator using the mean tardiness of a schedule.")]
   [StorableClass]
-  public class MeanTardinessEvaluator : SchedulingEvaluator {
+  public class MeanTardinessEvaluator : SchedulingEvaluator, IJSSPOperator {
     [StorableConstructor]
     protected MeanTardinessEvaluator(bool deserializing) : base(deserializing) { }
@@ -46,16 +47,16 @@
 
     #region Parameter Properties
-    public ILookupParameter<ItemList<Job>> JobsParameter {
-      get { return (ILookupParameter<ItemList<Job>>)Parameters["Jobs"]; }
+    public ILookupParameter<ItemList<Job>> JobDataParameter {
+      get { return (ILookupParameter<ItemList<Job>>)Parameters["JobData"]; }
     }
     #endregion
     #region Properties
-    public ItemList<Job> Jobs {
-      get { return JobsParameter.ActualValue; }
+    public ItemList<Job> JobData {
+      get { return JobDataParameter.ActualValue; }
     }
     #endregion
 
     public MeanTardinessEvaluator() : base() {
-      Parameters.Add(new LookupParameter<ItemList<Job>>("Jobs", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance."));
+      Parameters.Add(new LookupParameter<ItemList<Job>>("JobData", "Jobdata defining the precedence relationships and the duration of the tasks in this JSSP-Instance."));
     }
 
@@ -63,5 +64,5 @@
       double totalTardiness = 0;
       foreach (Resource r in schedule.Resources) {
-        double tardiness = r.Tasks[r.Tasks.Count - 1].EndTime.Value - Jobs[r.Tasks[r.Tasks.Count - 1].JobNr.Value].DueDate.Value;
+        double tardiness = r.Tasks[r.Tasks.Count - 1].EndTime.Value - JobData[r.Tasks[r.Tasks.Count - 1].JobNr.Value].DueDate.Value;
         if (tardiness > 0)
           totalTardiness += tardiness;
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluationAlgorithm.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluationAlgorithm.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluationAlgorithm.cs	(revision 6364)
@@ -35,15 +35,19 @@
 
 namespace HeuristicLab.Problems.Scheduling.Evaluators {
-  [Item("Scheduling Evaluator", "Represents a general evaluator class for scheduling problems.")]
+  [Item("Scheduling Evaluation Algorithm", "Represents a composition of a decoder and an evaluator for scheduling problems.")]
   [StorableClass]
-  public class SchedulingEvaluationAlgorithm : AlgorithmOperator, ISchedulingEvaluator {
+  public class SchedulingEvaluationAlgorithm : AlgorithmOperator, ISchedulingEvaluationAlgorithm {
     [StorableConstructor]
     protected SchedulingEvaluationAlgorithm(bool deserializing) : base(deserializing) { }
     protected SchedulingEvaluationAlgorithm(SchedulingEvaluationAlgorithm original, Cloner cloner)
       : base(original, cloner) {
+        this.evaluator = cloner.Clone(original.evaluator);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
       return new SchedulingEvaluationAlgorithm(this, cloner);
     }
+
+    [Storable]
+    private Placeholder evaluator;
 
     public ILookupParameter<DoubleValue> QualityParameter {
@@ -56,5 +60,5 @@
     }
 
-    public void InitializeOperatorGraph<T>(SchedulingDecoder<T> decoder, SchedulingEvaluator evaluator) where T: Item, ISchedulingEncoding{
+    public void InitializeOperatorGraph<T>(SchedulingDecoder<T> decoder) where T: Item, ISchedulingEncoding{
       OperatorGraph.Operators.Clear();
       OperatorGraph.InitialOperator = decoder;
@@ -65,4 +69,6 @@
       : base() {
         Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value aka fitness value of the solution."));
+        evaluator = new Placeholder();
+        evaluator.OperatorParameter.ActualName = "SolutionEvaluator";
     }
 
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluator.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Evaluators/SchedulingEvaluator.cs	(revision 6364)
@@ -35,5 +35,5 @@
 
 namespace HeuristicLab.Problems.Scheduling.Evaluators {
-  [Item("JSSP Evaluator", "Represents a evaluator class for standard job shop scheduling problems.")]
+  [Item("Scheduling Evaluator", "Represents a evaluator class for standard scheduling problems.")]
   [StorableClass]
   public abstract class SchedulingEvaluator : SingleSuccessorOperator, ISchedulingEvaluator {
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/HeuristicLab.Problems.Scheduling-3.3.csproj	(revision 6364)
@@ -56,6 +56,4 @@
     <Compile Include="Decoders\PRVDecoder.cs" />
     <Compile Include="Decoders\PWRDecoder.cs" />
-    <Compile Include="Evaluators\SchedulingEvaluatorType.cs" />
-    <Compile Include="Evaluators\SchedulingEvaluatorTypes.cs" />
     <Compile Include="Evaluators\MeanTardinessEvaluator.cs" />
     <Compile Include="Evaluators\MakespanEvaluator.cs" />
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPOperator.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPOperator.cs	(revision 6364)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Interfaces/IJSSPOperator.cs	(revision 6364)
@@ -0,0 +1,12 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Problems.Scheduling.Interfaces {
+  public interface IJSSPOperator : IOperator {
+     ILookupParameter<ItemList<Job>> JobDataParameter {get;}
+  }
+}
Index: branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Job.cs
===================================================================
--- branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Job.cs	(revision 6297)
+++ branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Job.cs	(revision 6364)
@@ -31,7 +31,7 @@
 
 namespace HeuristicLab.Problems.Scheduling {
-  [Item("Job Class", "Represents a composition of tasks that require processing in a job shop scheduling problem.")]
+  [Item("Job Class", "Represents a composition of tasks that require processing in a scheduling problem.")]
   [StorableClass]
-  public class Job : IndexedTaskList {
+  public class Job : Item {
     [StorableConstructor]
     protected Job(bool deserializing) : base(deserializing) { }
@@ -39,4 +39,6 @@
       : base(original, cloner) {
         this.DueDate = cloner.Clone(original.DueDate);
+        this.Index = cloner.Clone(original.Index);
+        this.Tasks = cloner.Clone(original.Tasks);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -46,5 +48,18 @@
     public DoubleValue DueDate { get; set; }
 
-    public Job(IntValue index, DoubleValue dueDate) : base (index) {
+    public IntValue Index {
+      get;
+      set;
+    }
+    public ItemList<Task> Tasks {
+      get;
+      set;
+    }
+
+
+    public Job(IntValue index, DoubleValue dueDate) : base () {
+      Index = index;
+      Tasks = new ItemList<Task>();
+
       if (dueDate != null)
         DueDate = (DoubleValue)dueDate.Clone();
